#include <stdlib.h>
#include "numberplateclass.hpp"

NumberPlateClass::NumberPlateClass( void )
{
}

NumberPlateClass::~NumberPlateClass( void )
{
}

bool NumberPlateClass::CreateQuestion( int width, int height )
{
	int i;
	Release();
	if( false == Create( width * 3, height * 3 ) )
	{
		return false;
	}
	for( i = 0; i < 81; i ++ )
	{
		int group_x;
		int group_y;
		int x;
		int y;
		int number;
		group_x = rand() % 3;
		group_y = rand() % 3;
		x = rand() % 3;
		y = rand() % 3;
		number = ( rand() % 9 ) + 1;
		if( 0 != GetNumber( group_x * 3 + x, group_y * 3 + y ) )
		{
			continue;
		}
		SetNumber( group_x * 3 + x, group_y * 3 + y, number );
		if( false == CheckVertical( group_x * 3 + x, group_y * 3 + y ) )
		{
			SetNumber( group_x * 3 + x, group_y * 3 + y, 0 );
		}
		else if( false == CheckHorizontal( group_x * 3 + x, group_y * 3 + y ) )
		{
			SetNumber( group_x * 3 + x, group_y * 3 + y, 0 );
		}
		else if( false == CheckGroup( group_x * 3 + x, group_y * 3 + y ) )
		{
			SetNumber( group_x * 3 + x, group_y * 3 + y, 0 );
		}
		else
		{
			SetChangeEnable( group_x * 3 + x, group_y * 3 + y, false );
		}
	}
	return true;
}

bool NumberPlateClass::CheckClear( void )
{
	int x;
	int y;
	int width;
	int height;
	width = GetWidth();
	height = GetHeight();
	for( y = 0; y < height; y ++ )
	{
		for( x = 0; x < width; x ++ )
		{
			if( 0 == GetNumber( x, y ) )
			{
				// SĖ܂ĂȂ
				return false;
			}
			if( false == CheckVertical( x, y ) )
			{
				// cɓ
				return false;
			}
			if( false == CheckHorizontal( x, y ) )
			{
				// cɓ
				return false;
			}
			if( false == CheckGroup( x, y ) )
			{
				// O[vɓ
				return false;
			}
		}
	}
	width /= 3;
	height /= 3;
	for( y = 0; y < height; y ++ )
	{
		for( x = 0; x < width; x ++ )
		{
			if( false == CheckGroup( x, y ) )
			{
				return false;
			}
		}
	}
	return true;
}

// c`FbN (cɓ true)
bool NumberPlateClass::CheckVertical( int x, int y )
{
	int i;
	int height;
	int number;
	number = GetNumber( x, y );
	height = GetHeight();
	for( i = 0; i < height; i ++ )
	{
		if( y == i )
		{
			continue;
		}
		if( 0 == number )
		{
			continue;
		}
		if( number == GetNumber( x, i ) )
		{
			return false;
		}
	}
	return true;
}

// `FbN (ɓ true)
bool NumberPlateClass::CheckHorizontal( int x, int y )
{
	int i;
	int width;
	int number;
	number = GetNumber( x, y );
	width = GetWidth();
	for( i = 0; i < width; i ++ )
	{
		if( x == i )
		{
			continue;
		}
		if( 0 == number )
		{
			continue;
		}
		if( number == GetNumber( i, y ) )
		{
			return false;
		}
	}
	return true;
}

// O[v`FbN (3x3 ɓ true)
bool NumberPlateClass::CheckGroup( int x, int y )
{
	int loop_x;
	int loop_y;
	int base_x;
	int base_y;
	int number;
	base_x = ( x / 3 ) * 3;
	base_y = ( y / 3 ) * 3;
	number = GetNumber( x, y );
	if( 0 == number )
	{
		return true;
	}
	for( loop_y = 0; loop_y < 3; loop_y ++ )
	{
		for( loop_x = 0; loop_x < 3; loop_x ++ )
		{
			if( ( ( base_x + loop_x ) == x ) && ( ( base_y + loop_y ) == y ) )
			{
				continue;
			}
			if( number == GetNumber( base_x + loop_x, base_y + loop_y ) )
			{
				return false;
			}
		}
	}
	return true;
}
