#include "plateclass.hpp"

PlateClass::PlateClass( void )
:Plate( 0 ), ChangeEnable( 0 ), Width( 0 ), Height( 0 )
{
}

PlateClass::~PlateClass( void )
{
}

bool PlateClass::Create( int width, int height )
{
	int i;
	if( 0 != Plate )
	{
		Release();
	}
	Width = width;
	Height = height;
	Plate = new int[ width * height ];
	ChangeEnable = new bool[ width * height ];
	for( i = 0; i < ( Width * Height ); i ++ )
	{
		Plate[ i ] = 0;
		ChangeEnable[ i ] = true;
	}
	return true;
}

void PlateClass::Release( void )
{
	delete [] Plate;
	delete [] ChangeEnable;
	Plate = 0;
	ChangeEnable = 0;
}

int PlateClass::GetWidth( void )
{
	if( 0 == Plate )
	{
		return -1;
	}
	return Width;
}

int PlateClass::GetHeight( void )
{
	if( 0 == Plate )
	{
		return -1;
	}
	return Height;
}

int PlateClass::GetNumber( int x, int y )
{
	if( 0 == Plate )
	{
		return -1;
	}
	if( Width <= x )
	{
		return -1;
	}
	if( Height <= y )
	{
		return -1;
	}
	return Plate[ y * Width + x ];
}

bool PlateClass::GetChangeEnable( int x, int y )
{
	if( 0 == Plate )
	{
		return false;
	}
	if( Width <= x )
	{
		return false;
	}
	if( Height <= y )
	{
		return false;
	}
	return ChangeEnable[ y * Width + x ];
}

bool PlateClass::SetNumber( int x, int y, int number )
{
	if( 0 == Plate )
	{
		return false;
	}
	if( Width <= x )
	{
		return false;
	}
	if( Height <= y )
	{
		return false;
	}
	Plate[ y * Width + x ] = number;
	return true;
}

bool PlateClass::SetChangeEnable( int x, int y, bool enable )
{
	if( 0 == Plate )
	{
		return false;
	}
	if( Width <= x )
	{
		return false;
	}
	if( Height <= y )
	{
		return false;
	}
	ChangeEnable[ y * Width + x ] = enable;
	return true;
}
